<?php
namespace Service\Calc\Strategy;
/**
*
* Intarface to calculate
* planed, spend, Remaining
*/

use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;

class NodeHourCalcStrategy implements HourCalcStrategyInterface
{
    /**
     * @param Entities\Task | Entities\Project $task
     * @return int
     */
    public function planned($task)
    {
        $planed = 0;
        if($task->hasChildren()){
            $children = $task->children();
            foreach ($children as $child) {
                if (!$child->isParent() && $child->isActive()) {
                    $planed += $child->getPlanned();
                }
            }
        }
        return $planed;
    }
    /**
     * @param Entities\Task | Entities\Project $task
     * @return int
     */

    public function spend($task)
    {
        $spend = 0;
        if($task->hasChildren()){
            $children = $task->children();
            foreach ($children as $child) {
                if (!$child->isParent() && $child->isActive()) {
                    $spend += $child->getSpend();
                }
            }
        }
        return $spend;
    }

    /**
     * @param Entities\Task | Entities\Project $task
     * @return int
     */
    public function remaining($task)
    {
        $remaining = 0;
        if($task->hasChildren()){
            $children = $task->children();
            foreach ($children as $child) {
                if (!$child->isParent() && $task->isValidateOfCalc($child) && $child->isActive()) {
                    $remaining += $child->getRemaining();
                }
            }
        }
        return $remaining;
    }

    /**
     * @param Entities\Task | Entities\Project $task
     * @return int
     */
    public function percentCompleted($task)
    {
        $percentCompleted = 0;
        if($task->getTableName() == Entities\Project::TABLE){
            $percentCompleted = InstanceProvider::getRepository()->getTask()->getPercentCompletedProject($task->getId());
        }else if($task->getTableName() == Entities\Task::TABLE){
            $percentCompleted = InstanceProvider::getRepository()->getTask()->getPercentCompletedTask($task->getId());
        }
        return $percentCompleted;
    }

    /**
     * @param Entities\Task | Entities\Project $task
     * @return int
     */
    public function progress($task)
    {
        if ($task->getPlanned() == 0) {
            return 0;
        }
        return (($task->getSpend() + $task->getRemaining()) / $task->getPlanned()) * 100;
    }
}