create or replace PROCEDURE USR_PROT_IMPORTA_CLIENTE(
   P_MENSAGEMERRO OUT VARCHAR2)
IS
   --GERAL
   V_NRINSJURCLIE  USR_CISPROT_CLIENTE.CGCCLIE%TYPE;
   V_CDCLIPROTHEUS USR_CISPROT_CLIENTE.CDCLIPROTHEUS%TYPE;
   V_NMRAZSOCCLIE  USR_CISPROT_CLIENTE.NMRAZAOSOC%TYPE;
   V_NMFANTCLIE    USR_CISPROT_CLIENTE.NMFANTCLIE%TYPE;
   V_DSENDECLIE    USR_CISPROT_CLIENTE.DSENDERECO%TYPE;
   V_CDPAIS        USR_CISPROT_CLIENTE.CDPAIS%TYPE;
   V_NMPAIS        USR_CISPROT_CLIENTE.NMPAIS%TYPE;
   V_SGESTADO      USR_CISPROT_CLIENTE.SGESTADO%TYPE;
   V_CDMUNCIPIO    USR_CISPROT_CLIENTE.CDMUNCIPIO%TYPE;
   V_NMMUNICIPIO   USR_CISPROT_CLIENTE.NMMUNICIPIO%TYPE;
   V_NRCEPCLIE     USR_CISPROT_CLIENTE.CDCEP%TYPE;
   V_NMBAIRRO      USR_CISPROT_CLIENTE.NMBAIRRO%TYPE;
   V_EMAIL         USR_CISPROT_CLIENTE.EMAIL%TYPE;
   V_CDFORMPGTO    USR_CISPROT_CLIENTE.CDFORMPGTO%TYPE;
   V_NMFORMPGTO    USR_CISPROT_CLIENTE.NMFORMPGTO%TYPE;
   V_IDCLIEATIV    USR_CISPROT_CLIENTE.IDCLIEATIV%TYPE;
   V_IDINTERFACE   USR_CISPROT_CLIENTE.IDINTERFACE%TYPE;
   V_CDBAIRRO		 BAIRRO.CDBAIRRO%TYPE;

   --ESPECIFICO TABELA INT
   V_LOG_ERRO      VARCHAR2(250);
   V_DTGRAVACAO    DATE;
   V_HRGRAVACAO    VARCHAR2(5);
   V_DTIMPORTACAO  DATE;
   V_HRIMPORTACAO  VARCHAR2(5);
   V_IDTPIJURCLIE  VARCHAR2(1);
   V_ERRO 			 VARCHAR2(5000);
   V_OBS			    VARCHAR2(5000);

   --VARIAVEIS LOCAIS MUTAVEIS
   V_EXISTEPAIS          NUMBER;
   V_EXISTEESTADO        NUMBER;
   V_EXISTEMUNICIPIO     NUMBER;
   V_EXISTEBAIRRO        NUMBER;
   V_JACADASTRADO        NUMBER;
   V_JARELACIONADO       NUMBER;
   V_EXISTEPGTO          NUMBER;
   JOB_N                 INT;
   V_TABELA              VARCHAR2(12);
   V_COMANDO             VARCHAR2(5000);

   CURSOR C_CLIENTE IS
      SELECT CGCCLIE AS NRINSJURCLIE, CDCLIPROTHEUS, NMRAZAOSOC AS NMRAZSOCCLIE, NMFANTCLIE, DSENDERECO AS DSENDECLIE,
             CDPAIS, NMPAIS, SGESTADO, CDMUNCIPIO, NMMUNICIPIO, CDCEP AS NRCEPCLIE, NMBAIRRO,
             EMAIL, CDFORMPGTO, NMFORMPGTO,  IDCLIEATIV, IDINTERFACE,
             LOG_ERRO, DTGRAVACAO, HRGRAVACAO, DTIMPORTACAO, HRIMPORTACAO,
            (CASE WHEN LENGTH(CGCCLIE) = 14 THEN 'J'
                  WHEN LENGTH(CGCCLIE) = 11  THEN 'F'
                  WHEN LENGTH(CGCCLIE) < 11  THEN 'O'
                  WHEN LENGTH(CGCCLIE) BETWEEN 12 AND 13 THEN 'I'
             END) AS IDTPIJURCLIE
       FROM USR_CISPROT_CLIENTE
      WHERE DTIMPORTACAO IS NULL;
BEGIN
   OPEN C_CLIENTE;
   LOOP
      FETCH C_CLIENTE INTO V_NRINSJURCLIE,
                           V_CDCLIPROTHEUS,
                           V_NMRAZSOCCLIE,
                           V_NMFANTCLIE,
                           V_DSENDECLIE,
                           V_CDPAIS,
                           V_NMPAIS,
                           V_SGESTADO,
                           V_CDMUNCIPIO,
                           V_NMMUNICIPIO,
                           V_NRCEPCLIE,
                           V_NMBAIRRO,
                           V_EMAIL,
                           V_CDFORMPGTO,
                           V_NMFORMPGTO,
                           V_IDCLIEATIV,
                           V_IDINTERFACE,
                           V_LOG_ERRO,
                           V_DTGRAVACAO,
                           V_HRGRAVACAO,
                           V_DTIMPORTACAO,
                           V_HRIMPORTACAO,
                           V_IDTPIJURCLIE;
      EXIT WHEN C_CLIENTE%NOTFOUND;

      V_ERRO := NULL;
      V_OBS  := NULL;
      P_MENSAGEMERRO := NULL;
      V_TABELA := 'CLIENTE';

      V_CDMUNCIPIO := SUBSTR(V_CDMUNCIPIO, 4, 4);
      V_CDPAIS := LPAD(V_CDPAIS, 4, '0');

      BEGIN
         SELECT COUNT(CDPAIS) INTO V_EXISTEPAIS FROM PAIS WHERE CDPAIS = V_CDPAIS;
         SELECT COUNT(SGESTADO) INTO V_EXISTEESTADO FROM ESTADO WHERE CDPAIS = V_CDPAIS AND SGESTADO = V_SGESTADO;
         SELECT COUNT(CDMUNICIPIO) INTO V_EXISTEMUNICIPIO FROM MUNICIPIO WHERE CDMUNICIPIO = V_CDMUNCIPIO AND SGESTADO = V_SGESTADO AND CDPAIS = V_CDPAIS;
         SELECT COUNT(CDCLIENTE) INTO V_JACADASTRADO FROM CLIENTE WHERE CDCLIENTE = V_IDTPIJURCLIE||V_NRINSJURCLIE;
         SELECT COUNT(CDFORMPGTO) INTO V_EXISTEPGTO FROM FORMPGTO WHERE CDFORMPGTO = V_CDFORMPGTO;
         SELECT COUNT(CDBAIRRO) INTO V_EXISTEBAIRRO FROM BAIRRO WHERE CDPAIS = V_CDPAIS AND SGESTADO = V_SGESTADO AND CDMUNICIPIO = V_CDMUNCIPIO AND NMBAIRRO = V_NMBAIRRO;

         IF (V_EXISTEPAIS = 0) THEN
            INSERT INTO PAIS
               (CDPAIS, NMPAIS, CDPAISBACEN)
            VALUES
               (V_CDPAIS, V_NMPAIS, V_CDPAIS);

            COMMIT;
         END IF;

         IF (V_EXISTEESTADO = 0) THEN
            INSERT INTO ESTADO
               (CDPAIS, SGESTADO, NMESTADO)
            VALUES
               (V_CDPAIS, V_SGESTADO, V_SGESTADO);

             COMMIT;
         END IF;

         IF (V_EXISTEMUNICIPIO = 0) THEN
            INSERT INTO MUNICIPIO
               (CDPAIS, SGESTADO, CDMUNICIPIO, NMMUNICIPIO, IDMUNIUTCONVNFE)
            VALUES
               (V_CDPAIS, V_SGESTADO, V_CDMUNCIPIO, V_NMMUNICIPIO, 'N');

            COMMIT;
         END IF;

         IF (V_EXISTEBAIRRO = 0) THEN
            SELECT LPAD(NVL(MAX(TO_NUMBER(CDBAIRRO)),0)+1, 10, 0) INTO V_CDBAIRRO FROM BAIRRO;

            INSERT INTO BAIRRO
               (CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, NMBAIRRO)
            VALUES
               (V_CDPAIS, V_SGESTADO, V_CDMUNCIPIO, V_CDBAIRRO, V_NMBAIRRO);
         ELSE
            SELECT CDBAIRRO INTO V_CDBAIRRO FROM BAIRRO WHERE CDPAIS = V_CDPAIS AND SGESTADO = V_SGESTADO AND CDMUNICIPIO = V_CDMUNCIPIO AND NMBAIRRO = V_NMBAIRRO;
         END IF;

         IF (V_EXISTEPGTO > 0) THEN
            UPDATE FORMPGTO
               SET NMFORMPGTO = V_NMFORMPGTO
             WHERE CDFORMPGTO = V_CDFORMPGTO;
         ELSE
            IF (V_CDFORMPGTO IS NOT NULL) THEN
               INSERT INTO FORMPGTO
                  (CDFORMPGTO, NMFORMPGTO, IDTIPODTPGTO, IDTPPERIODO, IDREFECALCPARC, IDCONSDIAUTIL)
               VALUES
                  (V_CDFORMPGTO, V_NMFORMPGTO, 'EMIN', 'M', 'DIA_DE_REFERENCIA', 'N');
            END IF;
         END IF;

         COMMIT;

         IF (V_JACADASTRADO = 1) THEN
            SELECT COUNT(CDCLIENTE) INTO V_JARELACIONADO FROM EXPORTCLIE WHERE CDCLIENTE = V_IDTPIJURCLIE||V_NRINSJURCLIE;
            IF (V_JARELACIONADO = 1) THEN
               UPDATE EXPORTCLIE
                  SET CDCLIEEXPORT = V_CDCLIPROTHEUS
                WHERE CDCLIENTE = V_IDTPIJURCLIE||V_NRINSJURCLIE;
            ELSE
               INSERT INTO EXPORTCLIE
                  (CDCLIENTE, CDCLIEEXPORT)
               VALUES
                  (V_IDTPIJURCLIE||V_NRINSJURCLIE, V_CDCLIPROTHEUS);
            END IF; -- JA RELACIONADO

            IF (V_IDINTERFACE <> 3) THEN
               V_IDINTERFACE := '2';
            END IF; -- nao pode mudar pra 2 caso excluso

         END IF; --JA CADASTRADO
      EXCEPTION
         WHEN OTHERS THEN
            V_ERRO := SQLERRM(SQLCODE);
            P_MENSAGEMERRO := V_ERRO;
      END;

      IF (V_IDINTERFACE = '1') THEN
         BEGIN
             INSERT INTO CLIENTE
                (CDCLIENTE, IDTPIJURCLIE, NMRAZSOCCLIE, NMFANTCLIE, NRINSJURCLIE,
                 IDUTDIAPGTCL, IDENDEMISCLI, IDENDCFOPCLI,
                 IDCLIEATIV, IDPRIPUBCLIE, IDCALCDVCLIE,
                 IDLIGEXTCLIE, IDGERNFCLIE,
                 DTCADACLIE, IDSITFINCLIE, IDGERANFPEDI, IDPGFRETTRANCLI,
                 IDGRAVOBSCLIPED, IDUTDESCICMS, IDCONSISTEPERFOS,
                 IDCONSFINAL, IDBLOQUEADO, IDCLIPRINCIPAL, IDCONTRIBICMS,
                 DSEMAILENVCL, DSEMAILCOMCL, CDFORMPGTO)
             VALUES
                (V_IDTPIJURCLIE||V_NRINSJURCLIE, V_IDTPIJURCLIE, V_NMRAZSOCCLIE, V_NMFANTCLIE, V_NRINSJURCLIE,
                 'I', 'P', 'P',
                 V_IDCLIEATIV, 'V', '1',
                 'N', '1',
                 SYSDATE, 'N', '1', '9',
                 'S', 'N', 'N',
                 'N', 'N', 'N', 'N',
                 SUBSTR(V_EMAIL, 0, 50), SUBSTR(V_EMAIL, 0, 50), V_CDFORMPGTO);

             INSERT INTO ENDECLIE
                (CDCLIENTE, IDTPENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO, DSENDECLIE, NMBAIRCLIE,
                 CDBAIRRO, NRCEPCLIE, DSEMAILCLIE ,DSEMAILCLIENFE, DSEMAILCLIECTE, DSEMAILCLIEMDFE)
             VALUES
                (V_IDTPIJURCLIE||V_NRINSJURCLIE, 'P', V_CDPAIS, V_SGESTADO, V_CDMUNCIPIO, V_DSENDECLIE, V_NMBAIRRO,
                 V_CDBAIRRO, V_NRCEPCLIE, SUBSTR(V_EMAIL, 0, 50), V_EMAIL, SUBSTR(V_EMAIL, 0, 60), SUBSTR(V_EMAIL, 0, 60));

             INSERT INTO EXPORTCLIE
                (CDCLIENTE, CDCLIEEXPORT)
             VALUES
                (V_IDTPIJURCLIE||V_NRINSJURCLIE, V_CDCLIPROTHEUS);

         EXCEPTION
            WHEN OTHERS THEN
               V_ERRO := SQLERRM(SQLCODE);
               P_MENSAGEMERRO := V_ERRO;
         END;
      END IF;

      IF (V_IDINTERFACE = '2') THEN
         BEGIN
            UPDATE CLIENTE
               SET NMRAZSOCCLIE = V_NMRAZSOCCLIE,
                   NMFANTCLIE   = V_NMFANTCLIE,
                   IDCLIEATIV   = V_IDCLIEATIV,
                   DSEMAILENVCL = SUBSTR(V_EMAIL, 0, 50),
                   DSEMAILCOMCL = SUBSTR(V_EMAIL, 0, 50),
                   CDFORMPGTO =  V_CDFORMPGTO
             WHERE CDCLIENTE  =  V_IDTPIJURCLIE||V_NRINSJURCLIE;

            UPDATE ENDECLIE
               SET CDPAIS     = V_CDPAIS,
                  SGESTADO    = V_SGESTADO,
                  CDMUNICIPIO = V_CDMUNCIPIO,
                  DSENDECLIE  = V_DSENDECLIE,
                  NMBAIRCLIE  = V_NMBAIRRO,
                  CDBAIRRO    = V_CDBAIRRO,
                  NRCEPCLIE = V_NRCEPCLIE,
                  DSEMAILCLIE = SUBSTR(V_EMAIL, 0, 50),
                  DSEMAILCLIENFE = V_EMAIL,
                  DSEMAILCLIECTE = SUBSTR(V_EMAIL, 0, 60),
                  DSEMAILCLIEMDFE = SUBSTR(V_EMAIL, 0, 60)
            WHERE CDCLIENTE = V_IDTPIJURCLIE||V_NRINSJURCLIE;

           UPDATE EXPORTCLIE
              SET CDCLIEEXPORT = V_CDCLIPROTHEUS
            WHERE CDCLIENTE = V_IDTPIJURCLIE||V_NRINSJURCLIE;

         EXCEPTION
            WHEN OTHERS THEN
               V_ERRO := SQLERRM(SQLCODE);
               P_MENSAGEMERRO := V_ERRO;
         END;

      END IF;

      IF (V_IDINTERFACE = '3') THEN
         BEGIN
            UPDATE CLIENTE
               SET IDCLIEATIV   = 'N'
             WHERE CDCLIENTE = V_IDTPIJURCLIE||V_NRINSJURCLIE;
         EXCEPTION
            WHEN OTHERS THEN
               V_ERRO := SQLERRM(SQLCODE);
               P_MENSAGEMERRO := V_ERRO;
         END;
      END IF;

      UPDATE USR_CISPROT_CLIENTE
         SET DTIMPORTACAO = SYSDATE,
             HRIMPORTACAO = TO_CHAR(SYSDATE, 'HH:MM'),
             LOG_ERRO = V_ERRO
       WHERE CGCCLIE = V_NRINSJURCLIE;

      COMMIT;
   END LOOP;
   CLOSE C_CLIENTE;

   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_PROT_IMPORTA_CLIENTE','6.35.038'); END;
/
