<?php
namespace Teknisa\Model\Gestaopessoas\Entities;

use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class GpeVinculom extends \Teknisa\Model\Gestaopessoas\Entities\Base\GpeVinculom {
    
    public function ajustaIntervaloAdmResc(&$data_ini, &$data_fim, $controleAdmissao) {
        
        $data_admissao = DateUtil::getDataDeString(substr($this->getDtadmissaovinc(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        $data_rescisao = null;

        if ($this->getDtrescisaovinc()) {
            $data_rescisao = DateUtil::getDataDeString(substr($this->getDtrescisaovinc(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        }
        
        $this->_admitidoPeriodo = false;
        $this->_demitidoPeriodo = false;
        $this->_admitidoMesAnterior = false;
        $this->_demitidoAnteriormente = false;

		$ultimodia = clone $data_fim;
        $ultimodia = DateUtil::getUltimoDiaDoMes($ultimodia);
		
        if ($data_admissao > $data_ini) {
            if ($data_admissao < $data_fim
                || $data_admissao->format('d/m/Y') == $data_fim->format('d/m/Y'))
            {
                $data_ini = $data_admissao; 
                $this->_admitidoPeriodo = true;
                if($controleAdmissao <= DateUtil::getDia($data_fim)){
                    $data_fim = DateUtil::setDay($data_fim, $controleAdmissao);
                }
            }
        } else {
            $data_ini_mes_anterior = DateUtil::subtraiIntervalo($data_ini, 1, DateUtil::MES);
            $data_ini_mes_anterior = DateUtil::setDay($data_ini_mes_anterior, 1);
            if (($data_admissao > $data_ini_mes_anterior)
                ||($data_admissao->format('d/m/Y') == $data_ini_mes_anterior->format('d/m/Y'))
            ) {
                $this->_admitidoMesAnterior = true;
            }
        }
        if ($data_rescisao) {
            if ($data_rescisao < $data_fim) {
                if (($data_rescisao > $data_ini)
                    ||($data_rescisao->format('d/m/Y') == $data_ini->format('d/m/Y'))
                ) {
                    $data_fim = $data_rescisao;
                    $this->_demitidoPeriodo = true;
                } else {
                    $this->_demitidoAnteriormente = true;
                    $data_fim = $data_rescisao;
                }
            }else{
                if ($data_rescisao > $data_fim){
					if (($data_rescisao < $ultimodia)
						||($data_rescisao->format('d/m/Y') == $ultimodia->format('d/m/Y'))
					) {
                        $data_fim = $data_rescisao;
						$this->_demitidoPosteriormente = true;
					}
                }
            }
        }
    }
    
}